/*
** DESCRIPTION: Diagonal traversal of a 2D matrix
** COMPILE:     g++ -o diagonal diagonal.c
** RUN:         ./diagonal
**
** As an aid in parallelizing the Gauss/Seidel relaxation with OpenMP
*/

#include <iostream>

using namespace std;

int main(int argc, char **argv)
{
	int i, j, ij;
	int n = 10;


	for (ij=1; ij<2*n-4; ij++) {

		int ja = (ij <= n-2) ? 1 : ij-(n-3);
		int je = (ij <= n-2) ? ij : n-2;

		for (j=ja; j<=je; j++) {

			i = ij-j+1;

			cout << i << "," << j << "  ";
		}
		cout << "\n";
	}
}
