#include <iostream>
#include <stdlib.h>

using namespace std;

int main()
{
	int i = 0, j = 1, k = 2;

	#pragma omp parallel private(i) firstprivate(j)
	{
		// i is private (but not initialized)
		// j is private and is initialized with the value of the master thread
		// k is shared a variable of all threads
        // h is private

		int h = random() % 100;
		#pragma omp critical
   		cout << "P: i=" << i << ", j=" << j << ", k=" << k << ", h=" << h << "\n";
   		i++; 
		j++;
		#pragma omp atomic
		k++;  // this access must be synchronized!
	}

	cout << "S: i=" << i << ", j=" << j << ", k=" << k << "\n";

	return 0;
}
